#define license tag if not already defined
%{!?_licensedir:%global license %doc}

# https://github.com/rolieup/golie
%global goipath         github.com/rolieup/golie
%global tag             v0.1.2

%global common_description %{expand:
A client/server implementation of ROLIE written in GO.}

%global golicenses      LICENSE LICENSE.NIST
%global godocs          examples README.md

Name:           golie
Version:        0.1.2
Release:        1%{?dist}
Summary:        A client/server implementation of ROLIE written in GO

# Upstream license specification: CC0-1.0
License:        CC0
URL:            %{gourl}
Source0:        %{name}-%{version}.tar.gz

BuildRequires:  git
BuildRequires:  golang-bin

# awk '{print "Provides: bundled(golang("$1")) = "$2}' go.sum  | sort | grep -v go.mod$
Provides: bundled(golang(github.com/davecgh/go-spew)) = v1.1.1
Provides: bundled(golang(github.com/gocomply/scap)) = 27dcc4e20641
Provides: bundled(golang(github.com/inconshreveable/mousetrap)) = v1.0.0
Provides: bundled(golang(github.com/konsorten/go-windows-terminal-sequences)) = v1.0.1
Provides: bundled(golang(github.com/pmezard/go-difflib)) = v1.0.0
Provides: bundled(golang(github.com/sirupsen/logrus)) = v1.4.2
Provides: bundled(golang(github.com/spf13/cobra)) = v0.0.5
Provides: bundled(golang(github.com/spf13/pflag)) = v1.0.3
Provides: bundled(golang(github.com/stretchr/testify)) = v1.2.2
Provides: bundled(golang(github.com/stretchr/testify)) = v1.5.1
Provides: bundled(golang(golang.org/x/sys)) = 953cdadca894
Provides: bundled(golang(golang.org/x/text)) = v0.3.0
Provides: bundled(golang(gopkg.in/check.v1)) = 20d25e280405
Provides: bundled(golang(gopkg.in/yaml.v2)) = v2.2.2

%description
%{common_description}

%gopkg

%prep
%autosetup -Sgit -n %{name}-%{version}

%build
export GO111MODULE=on
export GOPATH=$(pwd)/vendor:%{gopath}
export GOFLAGS=-mod=vendor

for cmd in cmd/* ; do
   %ifnarch ppc64
     # https://bugzilla.redhat.com/show_bug.cgi?id=995136#c12
     go build -buildmode pie -compiler gc -tags="rpm_crashtraceback ${BUILDTAGS:-}" -ldflags "${LDFLAGS:-} -B 0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \n') -extldflags '-Wl,-z,relro -Wl,--as-needed  -Wl,-z,now -specs=/usr/lib/rpm/redhat/redhat-hardened-ld '" -a -v -x \
       -o bin/$(basename $cmd) %{goipath}/$cmd
    %else
     go build                -compiler gc -tags="rpm_crashtraceback ${BUILDTAGS:-}" -ldflags "${LDFLAGS:-} -B 0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \n') -extldflags '-Wl,-z,relro -Wl,--as-needed  -Wl,-z,now -specs=/usr/lib/rpm/redhat/redhat-hardened-ld '" -a -v -x \
       -o bin/$(basename $cmd) %{goipath}/$cmd
    %endif
done

%install
install -m 0755 -vd                     %{buildroot}%{_bindir}
install -m 0755 -vp bin/*               %{buildroot}%{_bindir}/

install -m 0755 -vd                     %{buildroot}/usr/share/licenses/golie
install -m 0644 -vp LICENSE*            %{buildroot}/usr/share/licenses/golie

install -m 0755 -vd                     %{buildroot}/usr/share/doc/golie/
install -m 0644 -vp README.md           %{buildroot}/usr/share/doc/golie/
cp -pav             examples            %{buildroot}/usr/share/doc/golie/

%files
%license LICENSE LICENSE.NIST
%doc %{_docdir}/%{name}/
%doc %{_datadir}/licenses/%{name}/
%{_bindir}/*

%changelog
* Thu Jul 30 2020 Šimon Lukašík <slukasik@redhat.com> - 0.1.2-1
- new version

* Tue Jul 28 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.1.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Wed Jul 22 2020 Šimon Lukašík <slukasik@redhat.com> - 0.1.1-1
- Update to the latest upstram release

* Thu Jul 02 2020 Šimon Lukašík <slukasik@redhat.com> - 0-0.1.20200702git9dd93d8
- Initial package

